routes/web.php
<?php

use App\Http\Controllers\AdminController;
use App\Http\Controllers\AdminPermissionController;
use App\Http\Controllers\articlesController;
use App\Http\Controllers\AuthorAuthController;
use App\Http\Controllers\Cms\Auth\LoginController as AuthLoginController;
use App\Http\Controllers\AuthorAuthControole;
use App\Http\Controllers\authorController;
use App\Http\Controllers\categoryController;
use App\Http\Controllers\Cms\Auth\LoginController;
use App\Http\Controllers\Cms\HomeController as CmsHomeController;
use App\Http\Controllers\commentController;
use App\Http\Controllers\contactRequestController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\PermissionController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\RolePermissionController;
use App\Http\Controllers\SearchConrtoller;
use App\Http\Controllers\settingController;
use App\Http\Controllers\UserAuthController;
use App\Http\Controllers\UserController;
use App\Models\ContactRequest;
use GuzzleHttp\Middleware;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [HomeController::class,'index'])->name('home');

Route::get('/blog/{id}',  [HomeController::class,'show'])
->name('home-article');

Route::get('/author/{id}',  [HomeController::class,'showAuthor'])
->name('home-author');
Route::get('/category/{id}',  [HomeController::class,'showCategory'])
->name('home-category');

Route::post('/blog/{id}/comment',[HomeController::class,'StorCommment'])->name('comments-user')->middleware('auth:user');

// Route::get('/employee',[SearchConrtoller::class,'index']);
Route::post('/search',[SearchConrtoller::class,'showSearch'])->name('search');

// Route::prefix('cms/admin')->name('cms.')->middleware('guest:admin')->group(function(){
//     Route::get('login',[LoginController::class,'showLoginForm'])->name('login');
//     Route::post('login',[LoginController::class,'login'])->name('login');
//     // Auth::routes();
// });



Route::prefix('cms/author')->middleware('guest:author')->group(function () {
    Route::get('login', [AuthorAuthController::class, 'showLogin'])->name('auth-author.login.view');
    Route::post('login', [AuthorAuthController::class, 'login'])->name('auth-author.login');
});



Route::prefix('user')->middleware('guest:user')->group(function () {
    Route::get('login', [UserAuthController::class, 'showLogin'])->name('auth-user.login.view');
    Route::post('login', [UserAuthController::class, 'login'])->name('auth-user.login');
});




Route::get('cms/dashboard',[CmsHomeController::class,'index'])->name('cms.dashboard')
->middleware('auth:admin,author');




Route::prefix('cms/admin')->name('admin.')->middleware('guest:admin')->group(function(){
    Route::get('login',[AuthLoginController::class,'showLoginForm'])->name('auth.login.view');
    Route::post('login',[AuthLoginController::class,'login'])->name('login');
    // Auth::routes();
});



Route::get('logout', [UserAuthController::class, 'logout'])->name('auth-user.logout')->middleware('auth:user');




Route::prefix('cms')->middleware('auth:admin,author')->group(function(){
Route::resource('admins', AdminController::class);
// Route::view('', 'cms.dashboard')->name('cms.dashboard');
Route::resource('contacts', contactRequestController::class);
Route::resource('comments', commentController::class);


Route::resource('roles', RoleController::class);
Route::resource('permissions', PermissionController::class);

Route::resource('admins.permissions', AdminPermissionController::class);
Route::resource('role.permissions', RolePermissionController::class);

Route::resource('settings', settingController::class)->only(['index','store']);
Route::resource('users', UserController::class);
Route::resource('authors', authorController::class);
Route::resource('categories', categoryController::class);
Route::resource('articles', articlesController::class);


Route::get('edit-password', [AuthorAuthController::class, 'editPassword'])->name('auth.edit-password');
Route::put('update-password', [AuthorAuthController::class, 'updatePassword'])->name('auth.update-password');

Route::get('author/logout', [AuthorAuthController::class, 'logout'])->name('auth-author.logout');
Route::get('logout', [AuthLoginController::class, 'logout'])->name('auth.logout');



});
Route::view('lsl', 'cms.search.index');


// Auth::routes();

// Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Console\Command;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var string[]
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
    public function comments(){
        return $this->hasMany(Comment::class);
    }
    public function contactRecuests(){
        return $this->hasMany(ContactRequest::class);
    }
}

app/Http/Controllers/Cms/HomeController.php
<?php

namespace App\Http\Controllers\Cms;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        return view('cms.dashboard');

    }
}

app/Http/Controllers/RoleController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use Spatie\Permission\Models\Role;

class RoleController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $roles = Role::withCount('permissions')->paginate(10);
        return response()->view('cms.spatie.roles.index', ['roles' => $roles]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        return response()->view('cms.spatie.roles.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $validator = Validator($request->all(), [
            'guard' => 'required|string|in:admin,user',
            'name' => 'required|string|min:3'
        ]);

        if (!$validator->fails()) {
            $role = new Role();
            $role->name = $request->get('name');
            $role->guard_name = $request->get('guard');
            $isSaved = $role->save();
            return response()->json(['message' => $isSaved ? 'Role created succssefully' : "Failed to create roles"], $isSaved ? 200 : 400);
        } else {
            return response()->json(['message' => 'Please check required data'], 400);
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
        $role = Role::findById($id, 'admin');
        return response()->view('cms.spatie.roles.edit', ['role' => $role]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
        $validator = Validator($request->all(), [
            'guard' => 'required|string|in:admin,user',
            'name' => 'required|string|min:3'
        ]);

        if (!$validator->fails()) {
            $role = Role::findOrFail($id);
            $role->name = $request->get('name');
            $role->guard_name = $request->get('guard');
            $isSaved = $role->save();
            return response()->json(['message' => $isSaved ? 'Role updated succssefully' : "Failed to update roles"], $isSaved ? 200 : 400);
        } else {
            return response()->json(['message' => 'Please check required data'], 400);
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
        $isDeleted = Role::destroy($id);
        if ($isDeleted) {
            return response()->json(['title' => 'Deleted!', 'message' => 'Role Deleted Successfully', 'icon' => 'success'], 200);
        } else {
            return response()->json(['title' => 'Failed!', 'message' => 'Delete role failed', 'icon' => 'error'], 400);
        }
    }
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use App\Models\User;
use App\Models\users;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;

class UserController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $users=User::all();
        return response()->view('cms.user.index',['users'=>$users]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        return response()->view('cms.user.create');

    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $validator = Validator($request->all(), [
            'name' => 'required|string|min:2|max:45',
            'email' => 'required|email|unique:users,email',
            'mobile_number' => 'required|numeric|min:2|unique:users,mobile_number',
            'password' => 'required|string:users,password',
            'gender' => 'required|in:M,F|string',
            'status' => 'required|string|min:2|max:45'

        ]);

         if (!$validator->fails()) {
            $user = new User();
            $user->name = $request->get('name');
            $user->email = $request->get('email');
            $user->mobile_number = $request->get('mobile_number');
            $user->password = Hash::make($request->get('password'));
            $user->status = $request->get('status');
            $user->gender = $request->get('gender');
            $isSaved = $user->save();
         return response()->json(['message' => $isSaved ? 'Users created successfully' : 'Failed to create User!'], $isSaved ? 201 : 400);

        } else {
           return response()->json(['message' => $validator->getMessageBag()->first()], 422);
    }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
        $user=User::FindOrFail($id);

        return response()->view('cms.user.edit',['user'=>$user]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
        $validator = Validator($request->all(), [
            'name' => 'required|string|min:2|max:45',
            'email' => 'required|email|unique:users,email,'.$id,
            'mobile_number' => 'required|numeric|min:2|unique:users,mobile_number,'.$id,
            'gender' => 'required|in:M,F|string',
            'status' => 'required|string|min:2|max:45'

        ]);

         if (!$validator->fails()) {
            $user = user::findOrFail($id);
            $user->name = $request->get('name');
            $user->email = $request->get('email');
            $user->mobile_number = $request->get('mobile_number');
            $user->status = $request->get('status');
            $user->gender = $request->get('gender');
            $isSaved = $user->save();
         return response()->json(['message' => $isSaved ? 'user Updated successfully' : 'Failed to Update user!'], $isSaved ? 201 : 400);

        } else {
           return response()->json(['message' => $validator->getMessageBag()->first()], 422);
    }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
        $IsDeleted=User::destroy($id);
        if($IsDeleted){

            return response()->json(['titel'=>'Deleted','message'=>'User Deleted Successfully','icon'=>'success'],200);

        }else{
            return response()->json(['titel'=>'Failed','message'=>' Deleted User Failed','icon'=>'error'],400);


        }
    }
}

resources/views/cms/user/create.blade.php
@extends('cms.parent')

@section('title','Create User')
@section('page-name','Create User')
@section('main-page','Users')
@section('sub-page','Create User')

@section('styles')

<!-- Toastr -->
<link rel="stylesheet" href="{{ asset('cms/plugins/toastr/toastr.min.css') }}">


@endsection

@section('content')
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- general form elements -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">Create User</h3>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
              <form role="form" id="create_form" action="{{ route('users.store') }}" method="post" >
                @csrf
                <div class="card-body">

                <div class="form-grup">





                  <div class="form-group">
                    <label for="first_name">Name</label>
                    <input type="text" class="form-control" id="name" name="name" placeholder="Enter name"  required>
                    {{-- minlength="3" --}}
                </div>

                  <div class="form-group">
                    <label for="email">Email</label>
                    <input type="email" class="form-control" id="email" name="email" placeholder="Enter Email">
                  </div>
                  <div class="form-group">
                    <label for="mobile">Mobile Number</label>
                    <input type="tel" class="form-control" id="mobile_number" name="mobile_number" placeholder="Enter mobile_number">
                  </div>

                  <div class="form-group">
                    <label for="first_name">Password</label>
                    <input type="text" class="form-control" id="password" name="password" placeholder="Enter Password">
                  </div>

                  <div class="form-group">
                    <label for="first_name">Status</label>
                    <input type="text" class="form-control" id="status" name="status" placeholder="Enter Status">
                  </div>

                  <div class="form-group">
                    <div class="custom-control custom-radio">
                      <input class="custom-control-input" type="radio" id="male" value="M"  name="gender">
                      <label for="male" class="custom-control-label">Male</label>
                    </div>
                    <div class="custom-control custom-radio">
                      <input class="custom-control-input" type="radio" id="female" value="F" name="gender">
                      <label for="female" class="custom-control-label">Female</label>
                    </div>
                  </div>
                </div>
                <!-- /.card-body -->

                <div class="card-footer">
                    <button type="submit" class="btn btn-primary">Save</button>
                </div>
              </form>
            </div>
            <!-- /.card -->
          </div>
          <!--/.col (left) -->
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
@endsection

@section('scripts')
 <!-- bs-custom-file-input -->
<script src="{{ asset('cms/plugins/bs-custom-file-input/bs-custom-file-input.min.js') }}"></script>

<!-- Toastr -->
<script src="{{ asset('cms/plugins/toastr/toastr.min.js') }}"></script>


    <script>
        //  $('#create_form').validate();
        $('#create_form').submit(function(e){
            e.preventDefault();

            var data = new FormData(this);

            axios.post('{{ route('users.store') }}',data)
            .then(function (response) {
                console.log(response);
                document.getElementById('create_form').reset();
                showToaster(response.data.message, true);
            })
            .catch(function (error) {
                console.log(error.response);
                showToaster(error.response.data.message, false);
            });
        });

        function showToaster(message, status){
            if(status){
                toastr.success(message);
            }else{
                toastr.error(message);
            }
        }
    </script>

@endsection

resources/views/cms/user/edit.blade.php
@extends('cms.parent')

@section('title','Edit User')
@section('page-name','Edit User')
@section('main-page','Users')
@section('sub-page','Edit User ')

@section('styles')

<!-- Toastr -->


@endsection

@section('content')
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- general form elements -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">Edit User</h3>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
              <form role="form" id="edit_form" action="{{ route('users.update' , $user) }}" method="post" >
                @csrf
                @method('PUT')
                <div class="card-body">

                <div class="form-grup">





                  <div class="form-group">
                    <label for="first_name">Name</label>
                    <input type="text" class="form-control" id="name" value="{{ $user->name }}" name="name" placeholder="Enter name"  required>
                    {{-- minlength="3" --}}
                </div>

                  <div class="form-group">
                    <label for="email">Email</label>
                    <input type="email" class="form-control" id="email" name="email" value="{{ $user->email }}" placeholder="Enter Email">
                  </div>
                  <div class="form-group">
                    <label for="mobile">Mobile</label>
                    <input type="tel" class="form-control" id="mobile_number" name="mobile_number" value="{{$user->mobile_number}}" placeholder="Enter Mobile">
                  </div>



                  <div class="form-group">
                    <label for="first_name">Status</label>
                    <input type="text" class="form-control" id="status" name="status" value="{{ $user->status }}" placeholder="Enter Status">
                  </div>

                  <div class="form-group">
                    <div class="custom-control custom-radio">
                      <input class="custom-control-input" type="radio" id="male" value="M"  name="gender"
                      @if($user->gender == 'M') checked @endif
                      >
                      <label for="male" class="custom-control-label">Male</label>
                    </div>
                    <div class="custom-control custom-radio">
                      <input class="custom-control-input" type="radio" id="female" value="F" name="gender"
                      @if($user->gender == 'F') checked @endif
                      >
                      <label for="female" class="custom-control-label">Female</label>
                    </div>
                  </div>
                <!-- /.card-body -->

                <div class="card-footer">
                    <button type="submit" class="btn btn-primary">Save</button>
                </div>
              </form>
            </div>
            <!-- /.card -->
          </div>
          <!--/.col (left) -->
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
@endsection

@section('scripts')
 <!-- bs-custom-file-input -->
<script src="{{ asset('cms/plugins/bs-custom-file-input/bs-custom-file-input.min.js') }}"></script>

<!-- Toastr -->


    <script>
        //  $('#create_form').validate();
        $('#edit_form').submit(function(e){
            e.preventDefault();

            var data = new FormData(this);

            axios.post('{{ route('users.update',$user) }}',data)
            .then(function (response) {
                console.log(response);
                showToaster(response.data.message, true);
            })
            .catch(function (error) {
                console.log(error.response);
                showToaster(error.response.data.message, false);
            });
        });


    </script>

@endsection

resources/views/cms/user/index.blade.php
@extends('cms.parent')

@section('title','Users')
@section('page-name','Index Users')
@section('main-page','Users')
@section('sub-page','Index')

@section('styles')
<link href="https://unpkg.com/tailwindcss@^2/dist/tailwind.min.css" rel="stylesheet">
@endsection

@section('content')
<section class="content">
    <div class="container-fluid">
        <!-- /.row -->
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-header">
                        <h3 class="card-title">Users</h3>

                        <div class="card-tools">
                            <div class="input-group input-group-sm" style="width: 50px;">
                                <input type="text" name="table_search" class="form-control float-right"
                                    placeholder="Search">

                                <div class="input-group-append">
                                    <button type="submit" class="btn btn-default"><i class="fas fa-search"></i></button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- /.card-header -->
                    <div class="card-body table-responsive p-0">
                        <table class="table table-hover table-bordered text-nowrap">
                            <thead>
                                <tr>
                                    <th>#</th>
                                    <th>Name</th>
                                    <th>Email</th>
                                    <th>Mobile</th>
                                    <th>status</th>
                                    <th>Gender</th>
                                    <th>Created At</th>
                                    <th>Updated At</th>
                                    <th>Settings</th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach ($users as $user)
                                {{-- {{ dd($user) }} --}}
                                <tr>
                                    <td>{{ $user->id }}</td>
                                    <td>{{ $user->name}}</td>
                                    <td>{{ $user->email}}</td>
                                    <td>{{ $user->mobile_number }}</td>
                                    <td>{{ $user->status }}</td>
                                    <td><span class="badge bg-success">{{ $user->gender }}</span></td>
                                    {{-- <td><a href="{{ route('users.permissions.index',$user->id) }}"
                                            class="btn btn-info">{{ $user->permissions_count }} / Permissions <i
                                                class="fas fa-user-tie"></i></a></td> --}}
                                    {{-- <td>{{ $user->city->name }}</td> --}}
                                    <td>{{ $user->created_at->format('Y-m-d') }}</td>
                                    <td>{{ $user->updated_at->format('Y-m-d') }}</td>
                                    <td>
                                    <div class="btn-group">
                                            <a href="{{ route('users.edit',$user->id) }}" type="button"
                                                class="btn btn-info"><i class="fas fa-edit"></i></a>
                                            {{-- {{-- @if(Auth::user()->id != $user->id) --}}
                                            {{-- <form role="form" class="destroy" method="POST" action="{{ route('users.destroy',$user->id) }}">
                                                @csrf
                                                @method('DELETE')
                                                <button type="submit" class="btn btn-danger"><i class="fas fa-trash"></i></button>
                                            </form> --}}

                                            {{-- @endif  --}}
                                        {{-- </div> --}}

                                        <a href="#"  onclick="confirmDestroy({{ $user->id }},this)" class="btn btn-danger"><i class="fas fa-trash"></i></a>

                                    </td>
                                </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                    <div class="card-footer clearfix">
                        {{-- {{ $users->links() }} --}}
                        {{-- {{ $users->render }} --}}
                    </div>
                    <!-- /.card-body -->
                </div>
                <!-- /.card -->
            </div>
        </div>
        <!-- /.row -->
    </div>
</section>
@endsection

@section('scripts')
<script>
    function confirmDestroy(id, td){
        console.log('City ID:'+id);

        Swal.fire({
  title: 'Are you sure?',
  text: "You won't be able to revert this!",
  icon: 'warning',
  showCancelButton: true,
  confirmButtonColor: '#3085d6',
  cancelButtonColor: '#d33',
  confirmButtonText: 'Yes, delete it!'
}).then((result) => {
  if (result.isConfirmed) {
    destroy(id, td);
  }


});
    }
function destroy(id, td){
             axios.delete('/cms/users/'+id)
            .then(function (response) {
                console.log(response.data);

                swalAlert(response.data);
                td.closest('tr').remove();
            })
            .catch(function (error) {

            console.log(error.response);

            swalAlert(error.response.data);
                // console.log(error);
            })
            .then(function () {
                // always executed
  });
}

function swalAlert(data){

            Swal.fire({
            title: data.title,
            text: data.message,
            icon:data.icon,
            timer: 2000,
            timerProgressBar: false,
                    didOpen: () => {
            Swal.showLoading()
            timerInterval = setInterval(() => {
            const content = Swal.getHtmlContainer()
            if (content) {
                const b = content.querySelector('b')
                if (b) {
                b.textContent = Swal.getTimerLeft()
                }
            }
            }, 100)
        },
        willClose: () => {
            // clearInterval(timerInterval)
        }
        }).then((result) => {
        /* Read more about handling dismissals below */
        if (result.dismiss === Swal.DismissReason.timer) {
            console.log('I was closed by the timer')
        }
        })
}

</script>
@endsection